To use this patch, run these commands for a successful build:

    patch -p1 <patches/acls.diff
    ./prepare-source
    ./configure --enable-acl-support
    make

See the --acls (-A) option in the revised man page for a note on using this
latest ACL-enabling patch to send files to an older ACL-enabled rsync.

--- old/acls.c
+++ new/acls.c
@@ -0,0 +1,1094 @@
+/*
+ * Handle passing Access Control Lists between systems.
+ *
+ * Copyright (C) 1996 Andrew Tridgell
+ * Copyright (C) 1996 Paul Mackerras
+ * Copyright (C) 2006 Wayne Davison
+ *
+ * This program is free software; you can redistribute it and/or modify
+ * it under the terms of the GNU General Public License as published by
+ * the Free Software Foundation; either version 2 of the License, or
+ * (at your option) any later version.
+ *
+ * This program is distributed in the hope that it will be useful,
+ * but WITHOUT ANY WARRANTY; without even the implied warranty of
+ * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
+ * GNU General Public License for more details.
+ *
+ * You should have received a copy of the GNU General Public License along
+ * with this program; if not, write to the Free Software Foundation, Inc.,
+ * 51 Franklin Street - Fifth Floor, Boston, MA 02110-1301, USA.
+ */
+
+#include "rsync.h"
+#include "lib/sysacls.h"
+
+#ifdef SUPPORT_ACLS
+
+extern int dry_run;
+extern int read_only;
+extern int list_only;
+extern int orig_umask;
+extern int protocol_version;
+
+/* === ACL structures === */
+
+typedef struct {
+	id_t id;
+	uchar access;
+} id_access;
+
+typedef struct {
+	id_access *idas;
+	int count;
+} ida_entries;
+
+#define NO_ENTRY ((uchar)0x80)
+typedef struct rsync_acl {
+	ida_entries users;
+	ida_entries groups;
+	/* These will be NO_ENTRY if there's no such entry. */
+	uchar user_obj;
+	uchar group_obj;
+	uchar mask;
+	uchar other;
+} rsync_acl;
+
+typedef struct {
+	rsync_acl racl;
+	SMB_ACL_T sacl;
+} acl_duo;
+
+static const rsync_acl empty_rsync_acl = {
+	{NULL, 0}, {NULL, 0}, NO_ENTRY, NO_ENTRY, NO_ENTRY, NO_ENTRY
+};
+
+static item_list access_acl_list = EMPTY_ITEM_LIST;
+static item_list default_acl_list = EMPTY_ITEM_LIST;
+
+/* === Calculations on ACL types === */
+
+static const char *str_acl_type(SMB_ACL_TYPE_T type)
+{
+	return type == SMB_ACL_TYPE_ACCESS ? "SMB_ACL_TYPE_ACCESS"
+	     : type == SMB_ACL_TYPE_DEFAULT ? "SMB_ACL_TYPE_DEFAULT"
+	     : "unknown SMB_ACL_TYPE_T";
+}
+
+#define OTHER_TYPE(t) (SMB_ACL_TYPE_ACCESS+SMB_ACL_TYPE_DEFAULT-(t))
+#define BUMP_TYPE(t) ((t = OTHER_TYPE(t)) == SMB_ACL_TYPE_DEFAULT)
+
+static int count_racl_entries(const rsync_acl *racl)
+{
+	return racl->users.count + racl->groups.count
+	     + (racl->user_obj != NO_ENTRY)
+	     + (racl->group_obj != NO_ENTRY)
+	     + (racl->mask != NO_ENTRY)
+	     + (racl->other != NO_ENTRY);
+}
+
+static int calc_sacl_entries(const rsync_acl *racl)
+{
+	/* A System ACL always gets user/group/other permission entries. */
+	return racl->users.count + racl->groups.count
+#ifdef ACLS_NEED_MASK
+	     + 4;
+#else
+	     + (racl->mask != NO_ENTRY) + 3;
+#endif
+}
+
+/* Extracts and returns the permission bits from the ACL.  This cannot be
+ * called on an rsync_acl that has NO_ENTRY in any spot but the mask. */
+static int rsync_acl_get_perms(const rsync_acl *racl)
+{
+	return (racl->user_obj << 6)
+	     + ((racl->mask != NO_ENTRY ? racl->mask : racl->group_obj) << 3)
+	     + racl->other;
+}
+
+/* Removes the permission-bit entries from the ACL because these
+ * can be reconstructed from the file's mode. */
+static void rsync_acl_strip_perms(rsync_acl *racl)
+{
+	racl->user_obj = NO_ENTRY;
+	if (racl->mask == NO_ENTRY)
+		racl->group_obj = NO_ENTRY;
+	else {
+		if (racl->group_obj == racl->mask)
+			racl->group_obj = NO_ENTRY;
+		racl->mask = NO_ENTRY;
+	}
+	racl->other = NO_ENTRY;
+}
+
+/* Given an empty rsync_acl, fake up the permission bits. */
+static void rsync_acl_fake_perms(rsync_acl *racl, mode_t mode)
+{
+	racl->user_obj = (mode >> 6) & 7;
+	racl->group_obj = (mode >> 3) & 7;
+	racl->other = mode & 7;
+}
+
+/* === Rsync ACL functions === */
+
+static BOOL ida_entries_equal(const ida_entries *ial1, const ida_entries *ial2)
+{
+	id_access *ida1, *ida2;
+	int count = ial1->count;
+	if (count != ial2->count)
+		return False;
+	ida1 = ial1->idas;
+	ida2 = ial2->idas;
+	for (; count--; ida1++, ida2++) {
+		if (ida1->access != ida2->access || ida1->id != ida2->id)
+			return False;
+	}
+	return True;
+}
+
+static BOOL rsync_acl_equal(const rsync_acl *racl1, const rsync_acl *racl2)
+{
+	return racl1->user_obj == racl2->user_obj
+	    && racl1->group_obj == racl2->group_obj
+	    && racl1->mask == racl2->mask
+	    && racl1->other == racl2->other
+	    && ida_entries_equal(&racl1->users, &racl2->users)
+	    && ida_entries_equal(&racl1->groups, &racl2->groups);
+}
+
+/* Are the extended (non-permission-bit) entries equal?  If so, the rest of
+ * the ACL will be handled by the normal mode-preservation code.  This is
+ * only meaningful for access ACLs!  Note: the 1st arg is a fully-populated
+ * rsync_acl, but the 2nd parameter can be a condensed rsync_acl, which means
+ * that it might have several of its permission objects set to NO_ENTRY. */
+static BOOL rsync_acl_equal_enough(const rsync_acl *racl1,
+				   const rsync_acl *racl2, mode_t m)
+{
+	if ((racl1->mask ^ racl2->mask) & NO_ENTRY)
+		return False; /* One has a mask and the other doesn't */
+
+	/* When there's a mask, the group_obj becomes an extended entry. */
+	if (racl1->mask != NO_ENTRY) {
+		/* A condensed rsync_acl with a mask can only have no
+		 * group_obj when it was identical to the mask.  This
+		 * means that it was also identical to the group attrs
+		 * from the mode. */
+		if (racl2->group_obj == NO_ENTRY) {
+			if (racl1->group_obj != ((m >> 3) & 7))
+				return False;
+		} else if (racl1->group_obj != racl2->group_obj)
+			return False;
+	}
+	return ida_entries_equal(&racl1->users, &racl2->users)
+	    && ida_entries_equal(&racl1->groups, &racl2->groups);
+}
+
+static void rsync_acl_free(rsync_acl *racl)
+{
+	if (racl->users.idas)
+		free(racl->users.idas);
+	if (racl->groups.idas)
+		free(racl->groups.idas);
+	*racl = empty_rsync_acl;
+}
+
+void free_acl(statx *sxp)
+{
+	if (sxp->acc_acl) {
+		rsync_acl_free(sxp->acc_acl);
+		free(sxp->acc_acl);
+		sxp->acc_acl = NULL;
+	}
+	if (sxp->def_acl) {
+		rsync_acl_free(sxp->def_acl);
+		free(sxp->def_acl);
+		sxp->def_acl = NULL;
+	}
+}
+
+static int id_access_sorter(const void *r1, const void *r2)
+{
+	id_access *ida1 = (id_access *)r1;
+	id_access *ida2 = (id_access *)r2;
+	id_t rid1 = ida1->id, rid2 = ida2->id;
+	return rid1 == rid2 ? 0 : rid1 < rid2 ? -1 : 1;
+}
+
+static void sort_ida_entries(ida_entries *idal)
+{
+	if (!idal->count)
+		return;
+	qsort(idal->idas, idal->count, sizeof idal->idas[0], id_access_sorter);
+}
+
+/* Transfer the count id_access items out of the temp_ida_list into either
+ * the users or groups ida_entries list in racl. */
+static void save_idas(item_list *temp_ida_list, rsync_acl *racl, SMB_ACL_TAG_T type)
+{
+	id_access *idas;
+	ida_entries *ent;
+
+	if (temp_ida_list->count) {
+		int cnt = temp_ida_list->count;
+		id_access *temp_idas = temp_ida_list->items;
+		if (!(idas = new_array(id_access, cnt)))
+			out_of_memory("save_idas");
+		memcpy(idas, temp_idas, cnt * sizeof *temp_idas);
+	} else
+		idas = NULL;
+
+	ent = type == SMB_ACL_USER ? &racl->users : &racl->groups;
+
+	if (ent->count) {
+		rprintf(FERROR, "save_idas: disjoint list found for type %d\n", type);
+		exit_cleanup(RERR_UNSUPPORTED);
+	}
+	ent->count = temp_ida_list->count;
+	ent->idas = idas;
+
+	/* Truncate the temporary list now that its idas have been saved. */
+	temp_ida_list->count = 0;
+}
+
+/* === System ACLs === */
+
+/* Unpack system ACL -> rsync ACL verbatim.  Return whether we succeeded. */
+static BOOL unpack_smb_acl(rsync_acl *racl, SMB_ACL_T sacl)
+{
+	static item_list temp_ida_list = EMPTY_ITEM_LIST;
+	SMB_ACL_TAG_T prior_list_type = 0;
+	SMB_ACL_ENTRY_T entry;
+	const char *errfun;
+	int rc;
+
+	errfun = "sys_acl_get_entry";
+	for (rc = sys_acl_get_entry(sacl, SMB_ACL_FIRST_ENTRY, &entry);
+	     rc == 1;
+	     rc = sys_acl_get_entry(sacl, SMB_ACL_NEXT_ENTRY, &entry)) {
+		SMB_ACL_TAG_T tag_type;
+		SMB_ACL_PERMSET_T permset;
+		uchar access;
+		void *qualifier;
+		id_access *ida;
+		if ((rc = sys_acl_get_tag_type(entry, &tag_type))) {
+			errfun = "sys_acl_get_tag_type";
+			break;
+		}
+		if ((rc = sys_acl_get_permset(entry, &permset))) {
+			errfun = "sys_acl_get_tag_type";
+			break;
+		}
+		access = (sys_acl_get_perm(permset, SMB_ACL_READ) ? 4 : 0)
+		       | (sys_acl_get_perm(permset, SMB_ACL_WRITE) ? 2 : 0)
+		       | (sys_acl_get_perm(permset, SMB_ACL_EXECUTE) ? 1 : 0);
+		/* continue == done with entry; break == store in temporary ida list */
+		switch (tag_type) {
+		case SMB_ACL_USER_OBJ:
+			if (racl->user_obj == NO_ENTRY)
+				racl->user_obj = access;
+			else
+				rprintf(FINFO, "unpack_smb_acl: warning: duplicate USER_OBJ entry ignored\n");
+			continue;
+		case SMB_ACL_USER:
+			break;
+		case SMB_ACL_GROUP_OBJ:
+			if (racl->group_obj == NO_ENTRY)
+				racl->group_obj = access;
+			else
+				rprintf(FINFO, "unpack_smb_acl: warning: duplicate GROUP_OBJ entry ignored\n");
+			continue;
+		case SMB_ACL_GROUP:
+			break;
+		case SMB_ACL_MASK:
+			if (racl->mask == NO_ENTRY)
+				racl->mask = access;
+			else
+				rprintf(FINFO, "unpack_smb_acl: warning: duplicate MASK entry ignored\n");
+			continue;
+		case SMB_ACL_OTHER:
+			if (racl->other == NO_ENTRY)
+				racl->other = access;
+			else
+				rprintf(FINFO, "unpack_smb_acl: warning: duplicate OTHER entry ignored\n");
+			continue;
+		default:
+			rprintf(FINFO, "unpack_smb_acl: warning: entry with unrecognized tag type ignored\n");
+			continue;
+		}
+		if (!(qualifier = sys_acl_get_qualifier(entry))) {
+			errfun = "sys_acl_get_tag_type";
+			rc = EINVAL;
+			break;
+		}
+		if (tag_type != prior_list_type) {
+			if (prior_list_type)
+				save_idas(&temp_ida_list, racl, prior_list_type);
+			prior_list_type = tag_type;
+		}
+		ida = EXPAND_ITEM_LIST(&temp_ida_list, id_access, -10);
+		ida->id = *((id_t *)qualifier);
+		ida->access = access;
+		sys_acl_free_qualifier(qualifier, tag_type);
+	}
+	if (rc) {
+		rsyserr(FERROR, errno, "unpack_smb_acl: %s()", errfun);
+		rsync_acl_free(racl);
+		return False;
+	}
+	if (prior_list_type)
+		save_idas(&temp_ida_list, racl, prior_list_type);
+
+	sort_ida_entries(&racl->users);
+	sort_ida_entries(&racl->groups);
+
+#ifdef ACLS_NEED_MASK
+	if (!racl->users.count && !racl->groups.count && racl->mask != NO_ENTRY) {
+		/* Throw away a superfluous mask, but mask off the
+		 * group perms with it first. */
+		racl->group_obj &= racl->mask;
+		racl->mask = NO_ENTRY;
+	}
+#endif
+
+	return True;
+}
+
+/* Synactic sugar for system calls */
+
+#define CALL_OR_ERROR(func,args,str) \
+	do { \
+		if (func args) { \
+			errfun = str; \
+			goto error_exit; \
+		} \
+	} while (0)
+
+#define COE(func,args) CALL_OR_ERROR(func,args,#func)
+#define COE2(func,args) CALL_OR_ERROR(func,args,NULL)
+
+/* Store the permissions in the system ACL entry. */
+static int store_access_in_entry(uchar access, SMB_ACL_ENTRY_T entry)
+{
+	const char *errfun = NULL;
+	SMB_ACL_PERMSET_T permset;
+
+	COE( sys_acl_get_permset,(entry, &permset) );
+	COE( sys_acl_clear_perms,(permset) );
+	if (access & 4)
+		COE( sys_acl_add_perm,(permset, SMB_ACL_READ) );
+	if (access & 2)
+		COE( sys_acl_add_perm,(permset, SMB_ACL_WRITE) );
+	if (access & 1)
+		COE( sys_acl_add_perm,(permset, SMB_ACL_EXECUTE) );
+	COE( sys_acl_set_permset,(entry, permset) );
+
+	return 0;
+
+  error_exit:
+	rsyserr(FERROR, errno, "store_access_in_entry %s()", errfun);
+	return -1;
+}
+
+/* Pack rsync ACL -> system ACL verbatim.  Return whether we succeeded. */
+static BOOL pack_smb_acl(SMB_ACL_T *smb_acl, const rsync_acl *racl)
+{
+#ifdef ACLS_NEED_MASK
+	uchar mask_bits;
+#endif
+	size_t count;
+	id_access *ida;
+	const char *errfun = NULL;
+	SMB_ACL_ENTRY_T entry;
+
+	if (!(*smb_acl = sys_acl_init(calc_sacl_entries(racl)))) {
+		rsyserr(FERROR, errno, "pack_smb_acl: sys_acl_init()");
+		return False;
+	}
+
+	COE( sys_acl_create_entry,(smb_acl, &entry) );
+	COE( sys_acl_set_tag_type,(entry, SMB_ACL_USER_OBJ) );
+	COE2( store_access_in_entry,(racl->user_obj & 7, entry) );
+
+	for (ida = racl->users.idas, count = racl->users.count; count--; ida++) {
+		COE( sys_acl_create_entry,(smb_acl, &entry) );
+		COE( sys_acl_set_tag_type,(entry, SMB_ACL_USER) );
+		COE( sys_acl_set_qualifier,(entry, (void*)&ida->id) );
+		COE2( store_access_in_entry,(ida->access, entry) );
+	}
+
+	COE( sys_acl_create_entry,(smb_acl, &entry) );
+	COE( sys_acl_set_tag_type,(entry, SMB_ACL_GROUP_OBJ) );
+	COE2( store_access_in_entry,(racl->group_obj & 7, entry) );
+
+	for (ida = racl->groups.idas, count = racl->groups.count; count--; ida++) {
+		COE( sys_acl_create_entry,(smb_acl, &entry) );
+		COE( sys_acl_set_tag_type,(entry, SMB_ACL_GROUP) );
+		COE( sys_acl_set_qualifier,(entry, (void*)&ida->id) );
+		COE2( store_access_in_entry,(ida->access, entry) );
+	}
+
+#ifdef ACLS_NEED_MASK
+	mask_bits = racl->mask == NO_ENTRY ? racl->group_obj & 7 : racl->mask;
+	COE( sys_acl_create_entry,(smb_acl, &entry) );
+	COE( sys_acl_set_tag_type,(entry, SMB_ACL_MASK) );
+	COE2( store_access_in_entry,(mask_bits, entry) );
+#else
+	if (racl->mask != NO_ENTRY) {
+		COE( sys_acl_create_entry,(smb_acl, &entry) );
+		COE( sys_acl_set_tag_type,(entry, SMB_ACL_MASK) );
+		COE2( store_access_in_entry,(racl->mask, entry) );
+	}
+#endif
+
+	COE( sys_acl_create_entry,(smb_acl, &entry) );
+	COE( sys_acl_set_tag_type,(entry, SMB_ACL_OTHER) );
+	COE2( store_access_in_entry,(racl->other & 7, entry) );
+
+#ifdef DEBUG
+	if (sys_acl_valid(*smb_acl) < 0)
+		rprintf(FERROR, "pack_smb_acl: warning: system says the ACL I packed is invalid\n");
+#endif
+
+	return True;
+
+  error_exit:
+	if (errfun) {
+		rsyserr(FERROR, errno, "pack_smb_acl %s()", errfun);
+	}
+	sys_acl_free_acl(*smb_acl);
+	return False;
+}
+
+static int find_matching_rsync_acl(SMB_ACL_TYPE_T type,
+				   const item_list *racl_list,
+				   const rsync_acl *racl)
+{
+	static int access_match = -1, default_match = -1;
+	int *match = type == SMB_ACL_TYPE_ACCESS ? &access_match : &default_match;
+	size_t count = racl_list->count;
+
+	/* If this is the first time through or we didn't match the last
+	 * time, then start at the end of the list, which should be the
+	 * best place to start hunting. */
+	if (*match == -1)
+		*match = racl_list->count - 1;
+	while (count--) {
+		rsync_acl *base = racl_list->items;
+		if (rsync_acl_equal(base + *match, racl))
+			return *match;
+		if (!(*match)--)
+			*match = racl_list->count - 1;
+	}
+
+	*match = -1;
+	return *match;
+}
+
+/* Return the Access Control List for the given filename. */
+int get_acl(const char *fname, statx *sxp)
+{
+	SMB_ACL_TYPE_T type;
+
+	if (S_ISLNK(sxp->st.st_mode))
+		return 0;
+
+	type = SMB_ACL_TYPE_ACCESS;
+	do {
+		SMB_ACL_T sacl = sys_acl_get_file(fname, type);
+		rsync_acl *racl = new(rsync_acl);
+
+		if (!racl)
+			out_of_memory("get_acl");
+		*racl = empty_rsync_acl;
+		if (type == SMB_ACL_TYPE_ACCESS)
+			sxp->acc_acl = racl;
+		else
+			sxp->def_acl = racl;
+
+		if (sacl) {
+			BOOL ok = unpack_smb_acl(racl, sacl);
+
+			sys_acl_free_acl(sacl);
+			if (!ok) {
+				free_acl(sxp);
+				return -1;
+			}
+		} else if (errno == ENOTSUP || errno == ENOSYS) {
+			/* ACLs are not supported, so pretend we have a basic ACL. */
+			if (type == SMB_ACL_TYPE_ACCESS)
+				rsync_acl_fake_perms(racl, sxp->st.st_mode);
+		} else {
+			rsyserr(FERROR, errno, "get_acl: sys_acl_get_file(%s, %s)",
+				fname, str_acl_type(type));
+			free_acl(sxp);
+			return -1;
+		}
+	} while (BUMP_TYPE(type) && S_ISDIR(sxp->st.st_mode));
+
+	return 0;
+}
+
+/* === Send functions === */
+
+/* The general strategy with the tag_type <-> character mapping is that
+ * lowercase implies that no qualifier follows, where uppercase does.
+ * A similar idiom for the ACL type (access or default) itself, but
+ * lowercase in this instance means there's no ACL following, so the
+ * ACL is a repeat, so the receiver should reuse the last of the same
+ * type ACL. */
+
+/* Send the ida list over the file descriptor. */
+static void send_ida_entries(int f, const ida_entries *idal, char tag_char)
+{
+	id_access *ida;
+	size_t count = idal->count;
+	for (ida = idal->idas; count--; ida++) {
+		write_byte(f, tag_char);
+		write_byte(f, ida->access);
+		write_int(f, ida->id);
+		/* FIXME: sorta wasteful: we should maybe buffer as
+		 * many ids as max(ACL_USER + ACL_GROUP) objects to
+		 * keep from making so many calls. */
+		if (tag_char == 'U')
+			add_uid(ida->id);
+		else
+			add_gid(ida->id);
+	}
+}
+
+/* Send an rsync ACL over the file descriptor. */
+static void send_rsync_acl(int f, const rsync_acl *racl)
+{
+	size_t count = count_racl_entries(racl);
+	write_int(f, count);
+	if (racl->user_obj != NO_ENTRY) {
+		write_byte(f, 'u');
+		write_byte(f, racl->user_obj);
+	}
+	send_ida_entries(f, &racl->users, 'U');
+	if (racl->group_obj != NO_ENTRY) {
+		write_byte(f, 'g');
+		write_byte(f, racl->group_obj);
+	}
+	send_ida_entries(f, &racl->groups, 'G');
+	if (racl->mask != NO_ENTRY) {
+		write_byte(f, 'm');
+		write_byte(f, racl->mask);
+	}
+	if (racl->other != NO_ENTRY) {
+		write_byte(f, 'o');
+		write_byte(f, racl->other);
+	}
+}
+
+/* Send the ACL from the statx structure down the indicated file descriptor.
+ * This also frees the ACL data. */
+void send_acl(statx *sxp, int f)
+{
+	SMB_ACL_TYPE_T type;
+	rsync_acl *racl, *new_racl;
+	item_list *racl_list;
+	int ndx;
+
+	if (S_ISLNK(sxp->st.st_mode))
+		return;
+
+	type = SMB_ACL_TYPE_ACCESS;
+	racl = sxp->acc_acl;
+	racl_list = &access_acl_list;
+	do {
+		if (!racl) {
+			racl = new(rsync_acl);
+			if (!racl)
+				out_of_memory("send_acl");
+			*racl = empty_rsync_acl;
+			if (type == SMB_ACL_TYPE_ACCESS) {
+				rsync_acl_fake_perms(racl, sxp->st.st_mode);
+				sxp->acc_acl = racl;
+			} else
+				sxp->def_acl = racl;
+		}
+
+		/* Avoid sending values that can be inferred from other data. */
+		if (type == SMB_ACL_TYPE_ACCESS && protocol_version >= 30)
+			rsync_acl_strip_perms(racl);
+		if ((ndx = find_matching_rsync_acl(type, racl_list, racl)) != -1) {
+			write_byte(f, type == SMB_ACL_TYPE_ACCESS ? 'a' : 'd');
+			write_int(f, ndx);
+		} else {
+			new_racl = EXPAND_ITEM_LIST(racl_list, rsync_acl, 1000);
+			write_byte(f, type == SMB_ACL_TYPE_ACCESS ? 'A' : 'D');
+			send_rsync_acl(f, racl);
+			*new_racl = *racl;
+			*racl = empty_rsync_acl;
+		}
+		racl = sxp->def_acl;
+		racl_list = &default_acl_list;
+	} while (BUMP_TYPE(type) && S_ISDIR(sxp->st.st_mode));
+
+	free_acl(sxp);
+}
+
+/* === Receive functions === */
+
+static void receive_rsync_acl(rsync_acl *racl, int f, SMB_ACL_TYPE_T type)
+{
+	static item_list temp_ida_list = EMPTY_ITEM_LIST;
+	SMB_ACL_TAG_T tag_type = 0, prior_list_type = 0;
+	uchar computed_mask_bits = 0;
+	id_access *ida;
+	size_t count;
+
+	if (!(count = read_int(f)))
+		return;
+
+	while (count--) {
+		char tag = read_byte(f);
+		uchar access = read_byte(f);
+		if (access & ~ (4 | 2 | 1)) {
+			rprintf(FERROR, "receive_rsync_acl: bogus permset %o\n",
+				access);
+			exit_cleanup(RERR_STREAMIO);
+		}
+		switch (tag) {
+		case 'u':
+			if (racl->user_obj != NO_ENTRY) {
+				rprintf(FERROR, "receive_rsync_acl: error: duplicate USER_OBJ entry\n");
+				exit_cleanup(RERR_STREAMIO);
+			}
+			racl->user_obj = access;
+			continue;
+		case 'U':
+			tag_type = SMB_ACL_USER;
+			break;
+		case 'g':
+			if (racl->group_obj != NO_ENTRY) {
+				rprintf(FERROR, "receive_rsync_acl: error: duplicate GROUP_OBJ entry\n");
+				exit_cleanup(RERR_STREAMIO);
+			}
+			racl->group_obj = access;
+			continue;
+		case 'G':
+			tag_type = SMB_ACL_GROUP;
+			break;
+		case 'm':
+			if (racl->mask != NO_ENTRY) {
+				rprintf(FERROR, "receive_rsync_acl: error: duplicate MASK entry\n");
+				exit_cleanup(RERR_STREAMIO);
+			}
+			racl->mask = access;
+			continue;
+		case 'o':
+			if (racl->other != NO_ENTRY) {
+				rprintf(FERROR, "receive_rsync_acl: error: duplicate OTHER entry\n");
+				exit_cleanup(RERR_STREAMIO);
+			}
+			racl->other = access;
+			continue;
+		default:
+			rprintf(FERROR, "receive_rsync_acl: unknown tag %c\n",
+				tag);
+			exit_cleanup(RERR_STREAMIO);
+		}
+		if (tag_type != prior_list_type) {
+			if (prior_list_type)
+				save_idas(&temp_ida_list, racl, prior_list_type);
+			prior_list_type = tag_type;
+		}
+		ida = EXPAND_ITEM_LIST(&temp_ida_list, id_access, -10);
+		ida->access = access;
+		ida->id = read_int(f);
+		computed_mask_bits |= access;
+	}
+	if (prior_list_type)
+		save_idas(&temp_ida_list, racl, prior_list_type);
+
+	if (type == SMB_ACL_TYPE_DEFAULT) {
+		/* Ensure that these are never unset. */
+		if (racl->user_obj == NO_ENTRY)
+			racl->user_obj = 7;
+		if (racl->group_obj == NO_ENTRY)
+			racl->group_obj = 0;
+		if (racl->other == NO_ENTRY)
+			racl->other = 0;
+	}
+
+	if (!racl->users.count && !racl->groups.count) {
+		/* If we received a superfluous mask, throw it away. */
+		if (racl->mask != NO_ENTRY) {
+			/* Mask off the group perms with it first. */
+			racl->group_obj &= racl->mask | NO_ENTRY;
+			racl->mask = NO_ENTRY;
+		}
+	} else if (racl->mask == NO_ENTRY) /* Must be non-empty with lists. */
+		racl->mask = computed_mask_bits | (racl->group_obj & 7);
+}
+
+/* Receive the ACL info the sender has included for this file-list entry. */
+void receive_acl(struct file_struct *file, int f)
+{
+	SMB_ACL_TYPE_T type;
+	item_list *racl_list;
+
+	if (S_ISLNK(file->mode))
+		return;
+
+	type = SMB_ACL_TYPE_ACCESS;
+	racl_list = &access_acl_list;
+	do {
+		char tag = read_byte(f);
+		int ndx;
+
+		if (tag == 'A' || tag == 'a') {
+			if (type != SMB_ACL_TYPE_ACCESS) {
+				rprintf(FERROR, "receive_acl %s: duplicate access ACL\n",
+					f_name(file, NULL));
+				exit_cleanup(RERR_STREAMIO);
+			}
+		} else if (tag == 'D' || tag == 'd') {
+			if (type == SMB_ACL_TYPE_ACCESS) {
+				rprintf(FERROR, "receive_acl %s: expecting access ACL; got default\n",
+					f_name(file, NULL));
+				exit_cleanup(RERR_STREAMIO);
+			}
+		} else {
+			rprintf(FERROR, "receive_acl %s: unknown ACL type tag: %c\n",
+				f_name(file, NULL), tag);
+			exit_cleanup(RERR_STREAMIO);
+		}
+		if (tag == 'A' || tag == 'D') {
+			acl_duo *duo_item;
+			ndx = racl_list->count;
+			duo_item = EXPAND_ITEM_LIST(racl_list, acl_duo, 1000);
+			duo_item->racl = empty_rsync_acl;
+			receive_rsync_acl(&duo_item->racl, f, type);
+			duo_item->sacl = NULL;
+		} else {
+			ndx = read_int(f);
+			if (ndx < 0 || (size_t)ndx >= racl_list->count) {
+				rprintf(FERROR, "receive_acl %s: %s ACL index %d out of range\n",
+					f_name(file, NULL), str_acl_type(type), ndx);
+				exit_cleanup(RERR_STREAMIO);
+			}
+		}
+		if (type == SMB_ACL_TYPE_ACCESS)
+			F_ACL(file) = ndx;
+		else
+			F_DEF_ACL(file) = ndx;
+		racl_list = &default_acl_list;
+	} while (BUMP_TYPE(type) && S_ISDIR(file->mode));
+}
+
+/* Turn the ACL data in statx into cached ACL data, setting the index
+ * values in the file struct. */
+void cache_acl(struct file_struct *file, statx *sxp)
+{
+	SMB_ACL_TYPE_T type;
+	rsync_acl *racl;
+	item_list *racl_list;
+	int ndx;
+
+	if (S_ISLNK(file->mode))
+		return;
+
+	type = SMB_ACL_TYPE_ACCESS;
+	racl = sxp->acc_acl;
+	racl_list = &access_acl_list;
+	do {
+		if (!racl)
+			ndx = -1;
+		else if ((ndx = find_matching_rsync_acl(type, racl_list, racl)) == -1) {
+			acl_duo *new_duo;
+			ndx = racl_list->count;
+			new_duo = EXPAND_ITEM_LIST(racl_list, acl_duo, 1000);
+			new_duo->racl = *racl;
+			new_duo->sacl = NULL;
+			*racl = empty_rsync_acl;
+		}
+		if (type == SMB_ACL_TYPE_ACCESS)
+			F_ACL(file) = ndx;
+		else
+			F_DEF_ACL(file) = ndx;
+		racl = sxp->def_acl;
+		racl_list = &default_acl_list;
+	} while (BUMP_TYPE(type) && S_ISDIR(sxp->st.st_mode));
+
+	free_acl(sxp);
+}
+
+static mode_t change_sacl_perms(SMB_ACL_T sacl, rsync_acl *racl, mode_t old_mode, mode_t mode)
+{
+	SMB_ACL_ENTRY_T entry;
+	const char *errfun;
+	int rc;
+
+	if (S_ISDIR(mode)) {
+		/* If the sticky bit is going on, it's not safe to allow all
+		 * the new ACL to go into effect before it gets set. */
+#ifdef SMB_ACL_LOSES_SPECIAL_MODE_BITS
+		if (mode & S_ISVTX)
+			mode &= ~0077;
+#else
+		if (mode & S_ISVTX && !(old_mode & S_ISVTX))
+			mode &= ~0077;
+	} else {
+		/* If setuid or setgid is going off, it's not safe to allow all
+		 * the new ACL to go into effect before they get cleared. */
+		if ((old_mode & S_ISUID && !(mode & S_ISUID))
+		 || (old_mode & S_ISGID && !(mode & S_ISGID)))
+			mode &= ~0077;
+#endif
+	}
+
+	errfun = "sys_acl_get_entry";
+	for (rc = sys_acl_get_entry(sacl, SMB_ACL_FIRST_ENTRY, &entry);
+	     rc == 1;
+	     rc = sys_acl_get_entry(sacl, SMB_ACL_NEXT_ENTRY, &entry)) {
+		SMB_ACL_TAG_T tag_type;
+		if ((rc = sys_acl_get_tag_type(entry, &tag_type))) {
+			errfun = "sys_acl_get_tag_type";
+			break;
+		}
+		switch (tag_type) {
+		case SMB_ACL_USER_OBJ:
+			COE2( store_access_in_entry,((mode >> 6) & 7, entry) );
+			break;
+		case SMB_ACL_GROUP_OBJ:
+			/* group is only empty when identical to group perms. */
+			if (racl->group_obj != NO_ENTRY)
+				break;
+			COE2( store_access_in_entry,((mode >> 3) & 7, entry) );
+			break;
+		case SMB_ACL_MASK:
+#ifndef ACLS_NEED_MASK
+			/* mask is only empty when we don't need it. */
+			if (racl->mask == NO_ENTRY)
+				break;
+#endif
+			COE2( store_access_in_entry,((mode >> 3) & 7, entry) );
+			break;
+		case SMB_ACL_OTHER:
+			COE2( store_access_in_entry,(mode & 7, entry) );
+			break;
+		}
+	}
+	if (rc) {
+	  error_exit:
+		if (errfun) {
+			rsyserr(FERROR, errno, "change_sacl_perms: %s()",
+				errfun);
+		}
+		return (mode_t)~0;
+	}
+
+#ifdef SMB_ACL_LOSES_SPECIAL_MODE_BITS
+	/* Ensure that chmod() will be called to restore any lost setid bits. */
+	if (old_mode & (S_ISUID | S_ISGID | S_ISVTX)
+	 && BITS_EQUAL(old_mode, mode, CHMOD_BITS))
+		old_mode &= ~(S_ISUID | S_ISGID | S_ISVTX);
+#endif
+
+	/* Return the mode of the file on disk, as we will set them. */
+	return (old_mode & ~ACCESSPERMS) | (mode & ACCESSPERMS);
+}
+
+/* Set ACL on indicated filename.
+ *
+ * This sets extended access ACL entries and default ACL.  If convenient,
+ * it sets permission bits along with the access ACL and signals having
+ * done so by modifying sxp->st.st_mode.
+ *
+ * Returns 1 for unchanged, 0 for changed, -1 for failed.  Call this
+ * with fname set to NULL to just check if the ACL is unchanged. */
+int set_acl(const char *fname, const struct file_struct *file, statx *sxp)
+{
+	int unchanged = 1;
+	SMB_ACL_TYPE_T type;
+
+	if (!dry_run && (read_only || list_only)) {
+		errno = EROFS;
+		return -1;
+	}
+
+	if (S_ISLNK(file->mode))
+		return 1;
+
+	type = SMB_ACL_TYPE_ACCESS;
+	do {
+		acl_duo *duo_item;
+		int32 ndx;
+		BOOL eq;
+
+		if (type == SMB_ACL_TYPE_ACCESS) {
+			ndx = F_ACL(file);
+			if (ndx < 0 || (size_t)ndx >= access_acl_list.count)
+				continue;
+			duo_item = access_acl_list.items;
+			duo_item += ndx;
+			eq = sxp->acc_acl
+			    && rsync_acl_equal_enough(sxp->acc_acl, &duo_item->racl, file->mode);
+		} else {
+			ndx = F_DEF_ACL(file);
+			if (ndx < 0 || (size_t)ndx >= default_acl_list.count)
+				continue;
+			duo_item = default_acl_list.items;
+			duo_item += ndx;
+			eq = sxp->def_acl
+			    && rsync_acl_equal(sxp->def_acl, &duo_item->racl);
+		}
+		if (eq)
+			continue;
+		if (!dry_run && fname) {
+			if (type == SMB_ACL_TYPE_DEFAULT
+			 && duo_item->racl.user_obj == NO_ENTRY) {
+				if (sys_acl_delete_def_file(fname) < 0) {
+					rsyserr(FERROR, errno, "set_acl: sys_acl_delete_def_file(%s)",
+						fname);
+					unchanged = -1;
+					continue;
+				}
+			} else {
+				mode_t cur_mode = sxp->st.st_mode;
+				if (!duo_item->sacl
+				 && !pack_smb_acl(&duo_item->sacl, &duo_item->racl)) {
+					unchanged = -1;
+					continue;
+				}
+				if (type == SMB_ACL_TYPE_ACCESS) {
+					cur_mode = change_sacl_perms(duo_item->sacl, &duo_item->racl,
+								     cur_mode, file->mode);
+					if (cur_mode == (mode_t)~0)
+						continue;
+				}
+				if (sys_acl_set_file(fname, type, duo_item->sacl) < 0) {
+					rsyserr(FERROR, errno, "set_acl: sys_acl_set_file(%s, %s)",
+						fname, str_acl_type(type));
+					unchanged = -1;
+					continue;
+				}
+				if (type == SMB_ACL_TYPE_ACCESS)
+					sxp->st.st_mode = cur_mode;
+			}
+		}
+		if (unchanged == 1)
+			unchanged = 0;
+	} while (BUMP_TYPE(type) && S_ISDIR(file->mode));
+
+	return unchanged;
+}
+
+/* === Enumeration functions for uid mapping === */
+
+/* Context -- one and only one.  Should be cycled through once on uid
+ * mapping and once on gid mapping. */
+static item_list *_enum_racl_lists[] = {
+	&access_acl_list, &default_acl_list, NULL
+};
+
+static item_list **enum_racl_list = &_enum_racl_lists[0];
+static int enum_ida_index = 0;
+static size_t enum_racl_index = 0;
+
+/* This returns the next tag_type id from the given ACL for the next entry,
+ * or it returns 0 if there are no more tag_type ids in the acl. */
+static id_t *next_ace_id(SMB_ACL_TAG_T tag_type, const rsync_acl *racl)
+{
+	const ida_entries *idal = tag_type == SMB_ACL_USER ? &racl->users : &racl->groups;
+	if (enum_ida_index < idal->count) {
+		id_access *ida = &idal->idas[enum_ida_index++];
+		return &ida->id;
+	}
+	enum_ida_index = 0;
+	return NULL;
+}
+
+static id_t *next_acl_id(SMB_ACL_TAG_T tag_type, const item_list *racl_list)
+{
+	for (; enum_racl_index < racl_list->count; enum_racl_index++) {
+		id_t *id;
+		acl_duo *duo_item = racl_list->items;
+		duo_item += enum_racl_index;
+		if ((id = next_ace_id(tag_type, &duo_item->racl)) != NULL)
+			return id;
+	}
+	enum_racl_index = 0;
+	return NULL;
+}
+
+static id_t *next_acl_list_id(SMB_ACL_TAG_T tag_type)
+{
+	for (; *enum_racl_list; enum_racl_list++) {
+		id_t *id = next_acl_id(tag_type, *enum_racl_list);
+		if (id)
+			return id;
+	}
+	enum_racl_list = &_enum_racl_lists[0];
+	return NULL;
+}
+
+id_t *next_acl_uid()
+{
+	return next_acl_list_id(SMB_ACL_USER);
+}
+
+id_t *next_acl_gid()
+{
+	return next_acl_list_id(SMB_ACL_GROUP);
+}
+
+/* This is used by dest_mode(). */
+int default_perms_for_dir(const char *dir)
+{
+	rsync_acl racl;
+	SMB_ACL_T sacl;
+	BOOL ok;
+	int perms;
+
+	if (dir == NULL)
+		dir = ".";
+	perms = ACCESSPERMS & ~orig_umask;
+	/* Read the directory's default ACL.  If it has none, this will successfully return an empty ACL. */
+	sacl = sys_acl_get_file(dir, SMB_ACL_TYPE_DEFAULT);
+	if (sacl == NULL) {
+		/* Couldn't get an ACL.  Darn. */
+		switch (errno) {
+		case ENOTSUP:
+		case ENOSYS:
+			/* No ACLs are available. */
+			break;
+		case ENOENT:
+			if (dry_run) {
+				/* We're doing a dry run, so the containing directory
+				 * wasn't actually created.  Don't worry about it. */
+				break;
+			}
+			/* Otherwise fall through. */
+		default:
+			rprintf(FERROR, "default_perms_for_dir: sys_acl_get_file(%s, %s): %s, falling back on umask\n",
+				dir, str_acl_type(SMB_ACL_TYPE_DEFAULT), strerror(errno));
+		}
+		return perms;
+	}
+
+	/* Convert it. */
+	racl = empty_rsync_acl;
+	ok = unpack_smb_acl(&racl, sacl);
+	sys_acl_free_acl(sacl);
+	if (!ok) {
+		rprintf(FERROR, "default_perms_for_dir: unpack_smb_acl failed, falling back on umask\n");
+		return perms;
+	}
+
+	/* Apply the permission-bit entries of the default ACL, if any. */
+	if (racl.user_obj != NO_ENTRY) {
+		perms = rsync_acl_get_perms(&racl);
+		if (verbose > 2)
+			rprintf(FINFO, "got ACL-based default perms %o for directory %s\n", perms, dir);
+	}
+
+	rsync_acl_free(&racl);
+	return perms;
+}
+
+#endif /* SUPPORT_ACLS */
